function snake = build_snake(snake, link, joint, pp)
%% Build Snake
m=0;
m_tot = 0;
for i = 1 : snake.n
   %Build Links
    
   clink = link(snake.link_vec(i));
   m_tot = m_tot + clink.mass;
   snake.link(i).name   = clink.name;
   snake.link(i).length = clink.length;
   snake.link(i).radius = clink.radius;
   snake.link(i).M      = clink.M_R+clink.M_A;
   snake.link(i).drag   = clink.drag;
   snake.link(i).n_thruster = clink.n_thruster;
   
   w = clink.mass*pp.grav;
   b = clink.vol*pp.denw*pp.grav;
   snake.link(i).G = [(b-w)*eye(3); b*skew(clink.r_buoy)-w*skew(clink.r_grav)];
   
   m = m + clink.n_thruster;
   if clink.n_thruster > 0
   snake.link(i).B = [clink.t_thrust; cross(clink.r_thrust,clink.t_thrust)];
   else
   snake.link(i).B = [];
   end
   %Build Joints
   if i < snake.n
    cjoint = joint(snake.joint_vec(i));
    snake.joint(i).twist = cjoint.twist;
    snake.joint(i).A     =@(x)[cjoint.Rot(x), [clink.length 0 0]';
                               [0 0 0 1]];
   end
end
snake.n_thruster_tot = m;
end


