function output = calc_activation_matrix(sigma_dot, sigma, sigma_min, sigma_max)
%Calculates the activation matrix for a set based task.
%   If one of the scalar tasks in a vector task is not in the extended tanget
%   cone, the corresponding value A(i,i) in the activation matrix is equal
%   to 1, otherwise it is 0.
m = size(sigma,1);
count = 1;
A = zeros(m);
% for i=1:m
%     if (sigma_min(i) < sigma(i)) && (sigma(i) < sigma_max(i))
%         A(i,i) = 0;
%     elseif (sigma(i) <= sigma_min(i)) && (sigma_dot(i) >= 0)
%         A(i,i) = 0;
%     elseif (sigma <= sigma_min) && (sigma_dot < 0)
%         A(i,i) = 1;
%     elseif (sigma >= sigma_max) && (sigma_dot <= 0)
%         A(i,i) = 0;
%     else
%         A(i,i) = 1;
%     end
% end
for i=1:m
    if (sigma(i) <= sigma_min(i)) && (sigma_dot(i) < 0)
        A(count,i) = 1;
        count = count + 1;
    elseif (sigma(i) >= sigma_max(i)) && (sigma_dot(i) > 0)
        A(count,i) = 1;
        count = count + 1;
    end
end
output = A(any(A,2),:);
% output = A;
end

