function [out1, out2] = calc_activation_matrix_mod(sigma_ddot, sigma_dot, sigma, sigma_min, sigma_max)
%Calculates the activation matrix for a set based task.
%   If one of the scalar tasks in a vector task is not in the extended tangent
%   cone, the corresponding value A(p,i) in the activation matrix is equal
%   to 1, otherwise it is 0.
m = size(sigma,1);
p = 1;
A = zeros(m);
tasks = zeros(m,1);
for i=1:m
    if (sigma_min(i) < sigma(i)) && (sigma(i) < sigma_max(i))
        continue;
    elseif (sigma(i) <= sigma_min(i)) && (sigma_dot(i) >= 0)
        continue;
    elseif (sigma(i) >= sigma_max(i)) && (sigma_dot(i) <= 0)
        continue;
    else
        A(p,i) = 1;
        p = p + 1;
        tasks(i) = i;
    end
end
out1 = A(any(A,2),:);
out2 = tasks(any(tasks,2),:);
end