function link = define_link_properties_eely(pp, masscoeff, dragcoeff)


%Link 1, base module (tether + camera), module nr. 1.
link(1).name = '1';%'base module';
link(1).length = 0.62;
link(1).radius = 0.09;
link(1).vol = pi*link(1).radius^2*link(1).length; 
link(1).mass = link(1).vol*pp.denw;
link(1).r_grav = [0.5 0 0]'*link(1).length - [0 0 0.5]'*link(1).radius;
link(1).r_buoy = [0.5 0 0]'*link(1).length + [0 0 0]'*link(1).radius; %[1.4 0 0]';
link(1).M_R  = RBmass(link(1).r_grav,link(1).radius,link(1).length,link(1).mass); %Rigid body mass
link(1).M_A  = slendermass(link(1).length,pp.denw,link(1).radius,masscoeff); %Added mass
link(1).drag = @(x,y)drag(x,y,link(1).length,pp.denw,link(1).radius,dragcoeff);
link(1).n_thruster = 0;
link(1).t_thrust     = [ [0 0 0]' [0 0 0]' [0 0 0]']; %Thurster axis
link(1).r_thrust     = [ [0 0 0]' [0 0 0]' [0 0 0]']; %Thruster position
link(1).theta_thrust     = [ [0 0]' [0 0]' [0 0]']; %Thruster rotation

%Link 2, coupling 1, 2, 3 and 4, module nr. 2, 4, 6, 8.
link(2).name = '2';%'coupling without thursters';
link(2).length = 0.10;
link(2).radius = 0.09;
link(2).vol = pi*link(2).radius^2*link(2).length; 
link(2).mass = link(2).vol*pp.denw;
link(2).r_grav = [0.5 0 0]'*link(2).length - [0 0 0.5]'*link(2).radius;
link(2).r_buoy = [0.5 0 0]'*link(2).length + [0 0 0]'*link(2).radius;%[-1.5 0 0]';
link(2).M_R  = RBmass(link(2).r_grav,link(2).radius,link(2).length,link(2).mass); %Rigid body mass
link(2).M_A  = slendermass(link(2).length,pp.denw,link(2).radius,masscoeff); %Added mass
link(2).drag = @(x,y)drag(x,y,link(2).length,pp.denw,link(2).radius,dragcoeff);
link(2).n_thruster = 0;
link(2).t_thrust     = [ [0 0 0]' [0 0 0]' [0 0 0]']; %Thurster axis
link(2).r_thrust     = [ [0 0 0]' [0 0 0]' [0 0 0]']; %Thruster position
link(2).theta_thrust     = [ [0 0]' [0 0]' [0 0]']; %Thruster rotation

%Link 3, double module back, module nr. 3.
link(3).name = '3';%'double module back';
link(3).length = 0.59;
link(3).radius = 0.09;
link(3).vol = pi*link(3).radius^2*link(3).length; 
link(3).mass = link(3).vol*pp.denw;
link(3).r_grav = [0.5 0 0]'*link(3).length - [0 0 0.5]'*link(3).radius;
link(3).r_buoy = [0.5 0 0]'*link(3).length + [0 0 0]'*link(3).radius;%[1.6 0 0]';
link(3).M_R  = RBmass(link(3).r_grav,link(3).radius,link(3).length,link(3).mass); %Rigid body mass
link(3).M_A  = slendermass(link(3).length,pp.denw,link(3).radius,masscoeff); %Added mass
link(3).drag = @(x,y)drag(x,y,link(3).length,pp.denw,link(3).radius,dragcoeff);
link(3).n_thruster = 2;
link(3).t_thrust     = [[0 0 1]' [0 1 0]' [0 0 0]']; %Thurster axis
link(3).r_thrust     = [[0.24 0 0]' [0.35 0 0]' [0 0 0]']; %Thruster position
link(3).theta_thrust     = [[0 pi/2]' [pi/2 0]' [0 0]']; %Thruster rotation

%Link 4, center module, module nr. 5. 
link(4).name = '4';%'center module';
link(4).length = 0.80;
link(4).radius = 0.09;
link(4).vol = pi*link(4).radius^2*link(4).length; 
link(4).mass = link(4).vol*pp.denw;
link(4).r_grav = [0.5 0 0]'*link(4).length - [0 0 0.5]'*link(4).radius;
link(4).r_buoy = [0.5 0 0]'*link(4).length + [0 0 0]'*link(4).radius;%[-0.3 0 0]';
link(4).M_R  = RBmass(link(4).r_grav,link(4).radius,link(4).length,link(4).mass); %Rigid body mass
link(4).M_A  = slendermass(link(4).length,pp.denw,link(4).radius,masscoeff); %Added mass
link(4).drag = @(x,y)drag(x,y,link(4).length,pp.denw,link(4).radius,dragcoeff);
link(4).n_thruster = 3;
link(4).t_thrust     = [ [0 0 1]' [1 0 0]' [1 0 0]']; %Thurster axis
link(4).r_thrust     = [ [0.24 0 0]' [0.53 0.15 0]' [0.53 -0.15 0]']; %Thruster position
link(4).theta_thrust     = [[0 pi/2]' [0 0]' [0 0]']; %Thruster rotation

%Link 5, double module front, module nr. 7
link(5).name = '5';%'double module front';
link(5).length = 0.59;
link(5).radius = 0.09;
link(5).vol = pi*link(5).radius^2*link(5).length;
link(5).mass = link(5).vol*pp.denw;
link(5).r_grav = [0.5 0 0]'*link(5).length - [0 0 0.5]'*link(5).radius;
link(5).r_buoy = [0.5 0 0]'*link(5).length + [0 0 0]'*link(5).radius;%[1.6 0 0]';
link(5).M_R  = RBmass(link(5).r_grav,link(5).radius,link(5).length,link(5).mass); %Rigid body mass
link(5).M_A  = slendermass(link(5).length,pp.denw,link(5).radius,masscoeff); %Added mass
link(5).drag = @(x,y)drag(x,y,link(5).length,pp.denw,link(5).radius,dragcoeff);
link(5).n_thruster = 2;
link(5).t_thrust     = [ [0 1 0]' [0 0 1]' [0 0 0]']; %Thurster axis
link(5).r_thrust     = [ [0.24 0 0]' [0.35 0 0]' [0 0 0]']; %Thruster position
link(5).theta_thrust     = [[-pi/2 0]' [0 pi/2]' [0 0]']; %Thruster rotation

%Link 6, front module, module nr. 9.
link(6).name = '6';%'front module';
link(6).length = 0.37;
link(6).radius = 0.09;
link(6).vol = pi*link(6).radius^2*link(6).length; 
link(6).mass = link(6).vol*pp.denw;
link(6).r_grav = [0.5 0 0]'*link(6).length - [0 0 0.5]'*link(6).radius;
link(6).r_buoy = [0.5 0 0]'*link(6).length + [0 0 0]'*link(6).radius;%[1.1 0 0]';
link(6).M_R  = RBmass(link(6).r_grav,link(6).radius,link(6).length,link(6).mass); %Rigid body mass
link(6).M_A  = slendermass(link(6).length,pp.denw,link(6).radius,masscoeff); %Added mass
link(6).drag = @(x,y)drag(x,y,link(6).length,pp.denw,link(6).radius,dragcoeff);
link(6).n_thruster = 0;
link(6).t_thrust     = [ [0 0 0]' [0 0 0]' [0 0 0]']; %Thurster axis
link(6).r_thrust     = [ [0 0 0]' [0 0 0]' [0 0 0]']; %Thruster position
link(6).theta_thrust     = [[0 0]' [0 0]' [0 0]']; %Thruster rotation

%Link 7
link(7).name = 'link in cardan joints';
link(7).length = .02;
link(7).radius = .1;
link(7).mass = 0;
link(7).vol = link(1).mass/pp.denw;
link(7).r_grav = zeros(3,1);
link(7).r_buoy = zeros(3,1);
link(7).M_R  = zeros(6);
link(7).M_A  = zeros(6);
link(7).drag = @(x,~,~,~,~,~)zeros(6,1);
link(7).n_thruster = 0;

%Link 8
link(8).name = 'y,z thruster symmetric link';
link(8).length = .75;
link(8).radius = .1;
link(8).vol = pi*link(2).length*link(2).radius^2;
link(8).mass = link(2).vol*pp.denw;
link(8).r_grav = [0.5 0 0]'*link(2).length - [0 0 0.5]'*link(2).radius;
link(8).r_buoy = [0.5 0 0]'*link(2).length + [0 0 0]'*link(2).radius;
link(8).M_R  = RBmass(link(2).r_grav,link(2).radius,link(2).length,link(2).mass);
link(8).M_A  = slendermass(link(2).length,pp.denw,link(2).radius,masscoeff);
link(8).drag = @(x,y)drag(x,y,link(2).length,pp.denw,link(2).radius,dragcoeff);
link(8).n_thruster = 2;
link(8).t_thrust     = [ [0 1 0]' [0 0 1]'];
link(8).r_thrust     = [ [0.5 0 0]' [0.5 0 0]']*link(2).length;

%Link 9
link(9).name = 'x,x thruster middle symmetric link';
link(9).length = 1;
link(9).radius = .1;
link(9).vol = pi*link(3).length*link(3).radius^2;
link(9).mass = link(3).vol*pp.denw;
link(9).r_grav = [0.5 0 0]'*link(3).length - [0 0 0.5]'*link(3).radius;
link(9).r_buoy = [1 0 0]'*link(3).length + [0 0 0]'*link(3).radius;
link(9).M_R  = RBmass(link(3).r_grav,link(3).radius,link(3).length,link(3).mass);
link(9).M_A  = slendermass(link(3).length,pp.denw,link(3).radius,masscoeff);
link(9).drag = @(x,y)drag(x,y,link(3).length,pp.denw,link(3).radius,dragcoeff);
link(9).n_thruster   = 2;
link(9).t_thrust     = [ [1 0 0]' [1 0 0]'];
link(9).r_thrust     = [ [0 1.5 0]' [0 -1.5 0]']*link(3).radius;

end

