function link = define_link_properties_simple(pp, masscoeff, dragcoeff)

%Link 1
link(1).name = 'link in cardan joints';
link(1).length = .02;
link(1).radius = .1;
link(1).mass = 0;
link(1).vol = link(1).mass/pp.denw;
link(1).r_grav = zeros(3,1);
link(1).r_buoy = zeros(3,1);
link(1).M_R  = zeros(6);
link(1).M_A  = zeros(6);
link(1).drag = @(x,~,~,~,~,~)zeros(6,1);
link(1).n_thruster = 0;

%Link 2
link(2).name = 'y,z thruster symmetric link';
link(2).length = .75;
link(2).radius = .1;
link(2).vol = pi*link(2).length*link(2).radius^2;
link(2).mass = link(2).vol*pp.denw;
link(2).r_grav = [0.5 0 0]'*link(2).length - [0 0 0.5]'*link(2).radius;
link(2).r_buoy = [0.5 0 0]'*link(2).length + [0 0 0]'*link(2).radius;
link(2).M_R  = RBmass(link(2).r_grav,link(2).radius,link(2).length,link(2).mass);
link(2).M_A  = slendermass(link(2).length,pp.denw,link(2).radius,masscoeff);
link(2).drag = @(x,y)drag(x,y,link(2).length,pp.denw,link(2).radius,dragcoeff);
link(2).n_thruster = 2;
link(2).t_thrust     = [ [0 1 0]' [0 0 1]'];
link(2).r_thrust     = [ [0.5 0 0]' [0.5 0 0]']*link(2).length;

%Link 3
link(3).name = 'x,x thruster middle symmetric link';
link(3).length = 1;
link(3).radius = .1;
link(3).vol = pi*link(3).length*link(3).radius^2;
link(3).mass = link(3).vol*pp.denw;
link(3).r_grav = [0.5 0 0]'*link(3).length - [0 0 0.5]'*link(3).radius;
link(3).r_buoy = [1 0 0]'*link(3).length + [0 0 0]'*link(3).radius;
link(3).M_R  = RBmass(link(3).r_grav,link(3).radius,link(3).length,link(3).mass);
link(3).M_A  = slendermass(link(3).length,pp.denw,link(3).radius,masscoeff);
link(3).drag = @(x,y)drag(x,y,link(3).length,pp.denw,link(3).radius,dragcoeff);
link(3).n_thruster   = 2;
link(3).t_thrust     = [ [1 0 0]' [1 0 0]'];
link(3).r_thrust     = [ [0 1.5 0]' [0 -1.5 0]']*link(3).radius;
end