function out = qp_3_prilevel(x)
snake = evalin('base', 'snake');
% snake_err = evalin('base', 'snake_err');
pp = evalin('base','pp');
link = evalin('base', 'link');
K_1 = evalin('base', 'K_1');
K_2 = evalin('base', 'K_1');
%Get states
% snake     =  x(end)
pos       =  x(1:3);
quat      =  x(4:7);
theta     =  x(8:15);
zeta      =  x(16:29);
t         =  x(30);
pos_d     =  x(31:33);
quat_d    =  x(34:37);
att_d     =  x(38:40);
pos_d_dot =  x(41:43);
quat_d_dot = x(44:47);
att_d_dot =  x(48:50);
pos_ddot  =  x(51:53);
quat_d_ddot = x(54:57);
att_ddot  =  x(58:60);

DELTA_MAX = Inf;
uMIN = Inf;
uMAX = Inf;


persistent init_flag;
persistent u_prev;

if isempty(init_flag)
    init_flag = 0;
    u_prev = zeros(15,1);
end

%Compute rotation matrices and jacobians
[R, J]    =  comp_rot_jac(quat,theta,snake);

J_dot    = comp_jac_dot(theta, snake, J, zeta(7:end));


%Compute mass matrix
M         =  comp_mass(J,snake);
M_true         =  comp_mass(J,snake);
% M               = comp_mass(J,snake_err);
% norm(M-M_true)

%Compute relative velocity to take into account the effect of current
velc_h    =  R(:,:,1)'*pp.velc;
nu        =  zeta(1:6);
zeta(1:3) =  zeta(1:3)-velc_h;

%Compute coriolis, drag, and hydrostatic terms with the relative velocity
[c, d, g] =  comp_cdg(J,R,theta,snake,pp,zeta);
% [c_t, d_t, g_t] =  comp_cdg(J,R,theta,snake,pp,zeta);
% [c, d, g] =  comp_cdg(J,R,theta,snake_err,pp,zeta);

% norm(M\(-c-d-g) - M_true\(-c_t-d_t-g_t))
%Compute the thrust-configuration matrix
B         =  comp_TCM(J,snake);

%testing with a swimming gait, add your own controller here:
    % Homogenous transformation matrix between body-fixed base frame and
    % end-effector frame
    H_be = snake.joint(1).A(theta(1))*snake.joint(2).A(theta(2))*snake.joint(3).A(theta(3))*snake.joint(4).A(theta(4))*snake.joint(5).A(theta(5))*snake.joint(6).A(theta(6))*snake.joint(7).A(theta(7))*snake.joint(8).A(theta(8));
%     H_be_d = snake.joint(1).A(theta_d(1))*snake.joint(2).A(theta_d(2))*snake.joint(3).A(theta_d(3))*snake.joint(4).A(theta_d(4))*snake.joint(5).A(theta_d(5))*snake.joint(6).A(theta_d(6))*snake.joint(7).A(theta_d(7))*snake.joint(8).A(theta_d(8));
    % Position of end-effector in body-fixed base frame.
    pos_endeff = H_be*[snake.link(9).length;0;0;1];
    p_endeff = pos + R(:,:,1)*pos_endeff(1:3);
    A_e = [eye(3) [snake.link(9).length;0;0];
            zeros(1,3) 1];
    
    quat_endeff = rotm2quat(R(:,:,9))';
    T_0b = TransAngQ(quat_endeff);
%     quat_d = eul2quat(att_d','XYZ')';
    eta_d = quat_d(1);
    epsilon_d = quat_d(2:4);
    eta = quat_endeff(1);
    epsilon = quat_endeff(2:4);
    % Quaternion error
    qe = [eta_d*eta+epsilon_d'*epsilon;
         eta*epsilon_d-eta_d*epsilon+skew(epsilon)*epsilon_d];
    
%     if qe(1) < 0
%         qe(2:4) = -qe(2:4);
%     end
    
    V_e = Ad_inv(A_e)*J(:,:,9)*zeta;
    J_e = Ad_inv(A_e)*J(:,:,9);
    J_e_dot = Ad_inv(A_e)*J_dot(:,:,9);
    q_dot = T_0b*V_e(4:6);

     
%     J_1 = [R_d(:,:,9) zeros(3,3); zeros(3,3) T_0b(2:4,:)]*J_d(:,:,9);
%     J_1 = [R(:,:,9) zeros(3,3); zeros(3,3) T_0b(2:4,:)]*Ad_inv(A_e)*J(:,:,9);
%     J_1 = [R(:,:,9) zeros(3,3); zeros(3,3) R(:,:,9)]*Ad_inv(A_e)*J(:,:,9);
    J_11 = [R(:,:,9) zeros(3,3)]*Ad_inv(A_e)*J(:,:,9);
    J_12 = [zeros(3,3) R(:,:,9)]*Ad_inv(A_e)*J(:,:,9);
%     eul_endeff = rotm2eul(R(:,:,9),'XYZ');
%     T_eul = comp_T_eul(eul_endeff);
%      J_12 = T_eul*[zeros(3,3) eye(3)]*Ad_inv(A_e)*J(:,:,9);
     
%     att_dot = J_12*zeta;
%     T_eul_dot = comp_T_eul_dot(eul_endeff, att_dot);
    
    
%     J_12 = [zeros(3,3) T_0b(2:4,:)]*Ad_inv(A_e)*J(:,:,9);
%     J_1 = [R(:,:,9) zeros(3,3); zeros(3,3) T_0b(2:4,:)*R(:,:,9)]*Ad_inv(A_e)*J(:,:,9);
    T_0b_dot = 1/2.*[
                1 0 0 0 0 0 0 -1 0 0 1 0;
                0 0 0 1 1 0 0 0 0 -1 0 0;
                0 0 -1 0 0 1 0 0 1 0 0 0]*kron(eye(3),q_dot);
% T_0b_dot = 1/2.*[0 0 0 -1 0 0 0 -1 0 0 0 -1;
%                  1 0 0 0 0 0 0 0 1 0 -1 0;
%                  0 1 0 0 0 -1 0 0 0 1 0 0;
%                  0 0 1 0 1 0 -1 0 0 0 0 0]*kron(q_dot,eye(3)); 
%     J_1_dot = [R(:,:,9)*Smtrx(V_e(4:6)) zeros(3,3); zeros(3,3) T_0b_dot(2:4,:)]*Ad_inv(A_e)*J(:,:,9) + [R(:,:,9) zeros(3,3); zeros(3,3) T_0b(2:4,:)]*Ad_inv(A_e)*J_dot(:,:,9);
%     J_1_dot = [R(:,:,9)*Smtrx(V_e(4:6)) zeros(3,3); zeros(3,3) R(:,:,9)*Smtrx(V_e(4:6))]*Ad_inv(A_e)*J(:,:,9) + [R(:,:,9) zeros(3,3); zeros(3,3) R(:,:,9)]*Ad_inv(A_e)*J_dot(:,:,9);
    J_11_dot = [R(:,:,9)*Smtrx(V_e(4:6)) zeros(3,3)]*Ad_inv(A_e)*J(:,:,9) + [R(:,:,9) zeros(3,3)]*Ad_inv(A_e)*J_dot(:,:,9);
    J_12_dot = [zeros(3,3) R(:,:,9)*Smtrx(V_e(4:6))]*Ad_inv(A_e)*J(:,:,9) + [zeros(3,3) R(:,:,9)]*Ad_inv(A_e)*J_dot(:,:,9);
%     J_12_dot = T_eul*[zeros(3,3) eye(3)]*Ad_inv(A_e)*J_dot(:,:,9) + T_eul_dot*[zeros(3,3) eye(3)]*Ad_inv(A_e)*J(:,:,9);
%     J_12_dot = [zeros(3,3) T_0b_dot]*Ad_inv(A_e)*J(:,:,9) + [zeros(3,3) T_0b(2:4,:)]*Ad_inv(A_e)*J_dot(:,:,9);
  
    J_2 = [R(:,:,1) zeros(3,3+snake.n-1)];      % Base Jacobian
    J_2_dot = [R(:,:,1)*Smtrx(zeta(4:6)) zeros(3,3+snake.n-1)];

    J_b = [0 0 0 0 0 0 1 0 0 0 0 0 0 0;
           0 0 0 0 0 0 0 1 0 0 0 0 0 0;
           0 0 0 0 0 0 0 0 1 0 0 0 0 0;
           0 0 0 0 0 0 0 0 0 1 0 0 0 0;
           0 0 0 0 0 0 0 0 0 0 1 0 0 0;
           0 0 0 0 0 0 0 0 0 0 0 1 0 0;
           0 0 0 0 0 0 0 0 0 0 0 0 1 0;
           0 0 0 0 0 0 0 0 0 0 0 0 0 1];
    
    theta_max = 60*pi/180;
    sigma_b_max = theta_max.* ones(8,1);
    sigma_b_min = -sigma_b_max;

    h_3 = sigma_b_max - theta;
    h_4 = theta - sigma_b_min;

    h_3_dot = -J_b*zeta;
    h_4_dot = J_b*zeta;

%     alpha_31 = 3;
%     alpha_32 = 4;
    alpha_31 = K_1;
    alpha_32 = K_2;
    
    
    pos_obs = [2.5 0.5 -10]';
    radius_obs = 0.3;
    
    sigma_a1 = sqrt((pos_obs-p_endeff)'*(pos_obs-p_endeff));
    J_a_1 = -(pos_obs-p_endeff)'/(sigma_a1)*J_11;
    jac_sigmadot_p = eye(3)/sigma_a1 - (pos_obs-p_endeff)*(pos_obs-p_endeff)'/sigma_a1^3;
    J_a1_dot = (R(:,:,9)*V_e(1:3))'*jac_sigmadot_p*J_11-(pos_obs-p_endeff)'/(sigma_a1)*J_11_dot;

    h_2 = sigma_a1 - (radius_obs+0.02);
    h_2_dot = J_a_1*zeta;

    alpha_21 = 3;
    alpha_22 = 4;
%     alpha_21 = 0.15;
%     alpha_22 = .8;

    Lff_h3 = J_b/M*(c+d+g);
    Lff_h4 = -J_b/M*(c+d+g);
    Lgf_h3 = -J_b/M;
    Lgf_h4 = J_b/M;

    
%     sigma_1_tilde = [pos_d - p_endeff; qe(2:4)];
%     sigma_1_tilde = [pos_d - p_endeff; att_d-rotm2eul(R(:,:,9),'XYZ')'];
    sigma_11_tilde = pos_d - p_endeff;
%     sigma_12_tilde = att_d - rotm2eul(R(:,:,9),'XYZ')';
    sigma_12_tilde = qe(2:4);

%     sigma_1_tilde_dot = [0-R(:,:,9)*V_e(1:3); eps_tilde_dot];
    
    phi_d_dot = att_d_dot(1); theta_d_dot = att_d_dot(2); psi_d_dot = att_d_dot(3);
    phi_d = att_d(1);
    theta_d = att_d(2);
    psi_d = att_d(3);
    phi_dd = att_ddot(1);
    theta_dd = att_ddot(2);
    psi_dd = att_ddot(3);
    omega_d = [phi_d_dot - sin(theta_d)*psi_d_dot;
             cos(phi_d)*theta_d_dot + cos(theta_d)*sin(phi_d)*psi_d_dot;
             -sin(phi_d)*theta_d_dot + cos(theta_d)*cos(phi_d)*psi_d_dot];
         
    omega_ddot = [phi_dd-theta_d_dot*psi_d_dot*cos(theta_d)-sin(theta_d)*psi_dd;
                  -sin(phi_d)*phi_d_dot*theta_d_dot+cos(phi_d)*theta_dd+cos(theta_d)*sin(phi_d)*psi_dd-sin(phi_d)*sin(theta_d)*theta_d_dot*psi_d_dot+cos(theta_d)*cos(phi_d)*phi_d_dot*psi_d_dot;
                  -cos(phi_d)*phi_d_dot*theta_d_dot-sin(phi_d)*theta_dd-sin(theta_d)*cos(phi_d)*theta_d_dot*psi_d_dot-cos(theta_d)*sin(phi_d)*phi_d_dot*psi_d_dot ];

    T_q = TransAngQ(quat_d);
    T_q_inv = pinv(T_q);
    omega_d = T_q_inv*quat_d_dot;
    T_q_dot = 1/2.*[0 -1 0 0 0 0 -1 0 0 0 0 -1;
                1 0 0 0 0 0 0 -1 0 0 1 0;
                0 0 0 1 1 0 0 0 0 -1 0 0;
                0 0 -1 0 0 1 0 0 1 0 0 0]*kron(eye(3),quat_d_dot);
    alpha_d = T_q_inv*(quat_d_ddot-T_q_dot*omega_d);
         
    qe_dot= [-1/2*qe(2:4)'*(-R(:,:,9)*V_e(4:6)+omega_d);
            1/2*(qe(1)*eye(3)-skew(qe(2:4)))*(-R(:,:,9)*V_e(4:6)+omega_d)]; 
    
   
%     sigma_1_tilde_dot = [pos_d_dot-R(:,:,9)*V_e(1:3); omega_d-R(:,:,9)*V_e(4:6)];
%     sigma_1_tilde_dot = [pos_d_dot-R(:,:,9)*V_e(1:3); R(:,:,9)*omega_d-R(:,:,9)*V_e(4:6)];
    sigma_11_tilde_dot = pos_d_dot-R(:,:,9)*V_e(1:3);
%     sigma_12_tilde_dot = R(:,:,9)*(omega_d-V_e(4:6));
    sigma_12_tilde_dot = qe_dot(2:4);
%     omega_tilde = (omega_d-R(:,:,9)*V_e(4:6));
% %     eps_tilde_dot = 1/2.*qe(1)*omega_tilde +1/2*Smtrx(qe(2:4))*omega_tilde;
%     sigma_12_tilde_dot = eps_tilde_dot;
    
    sigma_2d = [0 0 -10]';
    
    sigma_2_tilde = sigma_2d - pos;
    sigma_2_tilde_dot = - R(:,:,1)*zeta(1:3);
    
%     sigma_3_tilde_dot = -zeta(7:13);
%     J_3 = J_b(1:7,:);
    sigma_3_tilde_dot = -zeta(7:end);
    J_3 = J_b;
    m_3 = size(J_3,1);
    
    B_joint = [zeros(6,8);eye(8)];
    B_full = [B B_joint];
    act_index = det(B_full*B_full');
    act_index_min = 0.1;
    [J_actuation, J_actuation_dot] = comp_actuation_task_jacobians(snake, B_full, theta, zeta(7:end));
    h_act = act_index - act_index_min;
    h_act_dot = J_actuation*zeta;
    
    % Poles at p_1 = -1 and p_2 = -3
    alpha_1 = 3;
    alpha_2 = 4;
    
    Lff_h = J_actuation_dot*zeta-J_actuation/M*(c+d+g);
    Lgf_h = J_actuation/M; 

    Lff_h2 = J_a1_dot*zeta-J_a_1/M*(c+d+g);
    Lgf_h2 = J_a_1/M;


    A_1 = J_11/M*B_full;
%     A_2 = J_12/M*B_full;
    A_2 = -1/2*(qe(1)*eye(3)-skew(qe(2:4)))*R(:,:,9)*J_e(4:6,:)/M*B_full;
    A_3 = J_2/M*B_full;
    A_4 = J_3/M*B_full;
%     A = [A_1;A_2];
    A = [A_1;A_2;A_3;A_4];
    A1 = [A_3;A_4];


%     p1 = 300;
%     p2 = 300;
%     p3 = 30;
%     p4 = 100;
    p1 = 100;
    p2 = 100;
    p3 = 100;
    p4 = 100;
    P1234 = diag([p1 p2]);
    H = 2*[P1234 zeros(2,15);
        zeros(15,2) A'*A];


    Lf1 = J_11_dot*zeta - J_11/M*(c+d+g) - pos_ddot;
%     Lf2 = J_12_dot*zeta - J_12/M*(c+d+g) + R(:,:,9)*omega_ddot;
%     Lf2 = J_12_dot*zeta - J_12/M*(c+d+g) - omega_ddot;
    Lf2 = 1/2*(qe(1)*eye(3)-skew(qe(2:4)))*(-R(:,:,9)*skew(V_e(4:6))*V_e(4:6) - R(:,:,9)*J_e_dot(4:6,:)*zeta +alpha_d + R(:,:,9)*J_e(4:6,:)/M*(c+d+g)) +1/2*(qe_dot(1)*eye(3)-skew(qe_dot(2:4)))*(omega_d-R(:,:,9)*V_e(4:6));

%     Lf2 = J_12_dot*zeta - J_12/M*(c+d+g) - att_ddot;
%     Lf1 = J_11_dot*zeta - J_11/M*(c+d+g);
%     Lf2 = J_12_dot*zeta - J_12/M*(c+d+g);
    Lf3 =     J_2_dot*zeta - J_2/M*(c+d+g);
    Lf4 = -J_3/M*(c+d+g);
    
    Lf = [Lf1;Lf2;Lf3;Lf4];
%     Lf = [Lf1;Lf2];
    Lf_1 = [Lf3;Lf4];
    
    F1 = [zeros(3,3) eye(3); zeros(3,6)];
    F2 = [zeros(3,3) eye(3); zeros(3,6)];
    F3 = [zeros(3,3) eye(3); zeros(3,6)];
    F4 = zeros(m_3,m_3);
    G1 = [zeros(3,3); eye(3)];
    G2 = [zeros(3,3); eye(3)];
    G3 = [zeros(3,3); eye(3)];
    G4 = eye(m_3);

    Q1 = eye(6);
    Q2 = eye(6);
    Q3 = eye(6);
    Q4 = eye(m_3);
    
    [P1, ~, ~] = care(F1,G1,Q1);
    [P2, ~, ~] = care(F2,G2,Q2);
    [P3, ~, ~] = care(F3,G3,Q3);
    [P4, ~, ~] = care(F4,G4,Q4);
    
    gamma_1 = min(eig(Q1))/max(eig(P1));
    gamma_2 = min(eig(Q2))/max(eig(P2));
    gamma_3 = min(eig(Q3))/max(eig(P3));
    gamma_4 = min(eig(Q4))/max(eig(P4));

%     eps1 = .78;
    eps1 = 1.2;
    eps2 = 0.9;
    eps3 = 1.7;
    eps4 = 1.1;
    
    Eps1 = [1/eps1*eye(3) zeros(3,3);
            zeros(3,3) eye(3)];
    Eps2 = [1/eps2*eye(3) zeros(3,3);
            zeros(3,3) eye(3)];
    Eps3 = [1/eps3*eye(3) zeros(3,3);
            zeros(3,3) eye(3)];
    Eps4 = 1/eps4*eye(m_3);
    
    P1 = Eps1*P1*Eps1;
    P2 = Eps2*P2*Eps2;
    P3 = Eps3*P3*Eps3;
    P4 = Eps4*P4*Eps4;
    
    
    eta_1 = -[sigma_11_tilde; sigma_11_tilde_dot];
    eta_2 = [sigma_12_tilde; sigma_12_tilde_dot];
    eta_3 = -[sigma_2_tilde; sigma_2_tilde_dot];
    eta_4 = -sigma_3_tilde_dot;

    
    psi_11 = (2*eta_1'*P1*G1)';
    psi_12 = (2*eta_2'*P2*G2)';
    psi_13 = (2*eta_3'*P3*G3)';
    psi_14 = (2*eta_4'*P4*G4)';
    
    
    

    
    psi_01 = eta_1'*(F1'*P1+P1*F1)*eta_1 + gamma_1/eps1*eta_1'*P1*eta_1;
    psi_02 = eta_2'*(F2'*P2+P2*F2)*eta_2 + gamma_2/eps2*eta_2'*P2*eta_2;
    
    psi_03 = eta_3'*(F3'*P3+P3*F3)*eta_3 + gamma_3/eps3*eta_3'*P3*eta_3;

    
    psi_04 = eta_4'*(F4'*P4+P4*F4)*eta_4 + gamma_4/eps4*eta_4'*P4*eta_4;

   
    Aineq = [
        -1 0 psi_11'*A_1;
        0 -1 psi_12'*A_2;
%         0 0 -1 0 psi_131'*A_3;
%         0 0 -1 0 psi_132'*A_3;
%         0 0 -1 psi_141'*A_4;
%         0 0 -1 psi_142'*A_4;
        0 0  -Lgf_h*B_full;
        0 0  -Lgf_h2*B_full;
        zeros(8,2) -Lgf_h3*B_full;
        zeros(8,2) -Lgf_h4*B_full;
        zeros(15,2) eye(15);
        zeros(15,2) -eye(15)];
    b = [-psi_01-psi_11'*Lf1;
         -psi_02-psi_12'*Lf2;
%          -psi_03-psi_131'*Lf3;
%          -psi_03-psi_132'*Lf3;
%          -psi_04-psi_141'*Lf4;
%          -psi_04-psi_142'*Lf4;
         Lff_h+alpha_1*h_act + alpha_2*h_act_dot;
         Lff_h2+alpha_21*h_2 + alpha_22*h_2_dot;
         Lff_h3+alpha_31*h_3 + alpha_32*h_3_dot;
         Lff_h4+alpha_31*h_4 + alpha_32*h_4_dot;
         uMIN*ones(15,1);
         uMAX*ones(15,1)];    
 
    f = [0 0 2*Lf'*A];
    
%     delta_u_max = [Inf; Inf; Inf; Inf; 0.5*ones(15,1)];
    delta_u_max = [Inf; Inf; DELTA_MAX*ones(15,1)];
%     delta_u_max = [ Inf; Inf; Inf*ones(15,1)];
    lb = [zeros(2,1);u_prev] - delta_u_max;
    ub = [zeros(2,1);u_prev] + delta_u_max;


    opts = optimoptions('quadprog','Display','off');
    u = quadprog(H,f,Aineq,b,[],[],lb,ub,[],opts);

%     H1 = 2*[diag([p3 p4]) zeros(2,15);
%              zeros(15,2) A'*A];
    H1 = 2*[p3 zeros(1,15);
             zeros(15,1) A'*A];

%     f1 = [0 0 2*Lf_1'*A1];
    f1 = [0 2*Lf'*A];
    Aineq1 = [
        -1 psi_13'*A_3;
        0 -Lgf_h*B_full;
        0 -Lgf_h2*B_full;
        zeros(8,1) -Lgf_h3*B_full;
        zeros(8,1) -Lgf_h4*B_full;
        zeros(15,1) eye(15);
        zeros(15,1) -eye(15)
        ];

    b1 = [-psi_03-psi_13'*Lf3;
         Lff_h+alpha_1*h_act + alpha_2*h_act_dot;
         Lff_h2+alpha_21*h_2 + alpha_22*h_2_dot;
         Lff_h3+alpha_31*h_3 + alpha_32*h_3_dot;
         Lff_h4+alpha_31*h_4 + alpha_32*h_4_dot;
         uMAX*ones(15,1);
         uMIN*ones(15,1)
         ];
    
    Aeq = [0 psi_11'*A_1;
           0 psi_12'*A_2;];
    beq = [psi_11'*A_1*u(3:end);
           psi_12'*A_2*u(3:end)];
       
    delta_u_max = [Inf; DELTA_MAX*ones(15,1)];
%     delta_u_max = [Inf; Inf; Inf*ones(15,1)];
    lb = [0;u_prev] - delta_u_max;
    ub = [0;u_prev] + delta_u_max;

    u = quadprog(H1,f1,Aineq1,b1,Aeq,beq,lb,ub,[],opts);

    H2 = 2*[p4 zeros(1,15);
             zeros(15,1) A'*A];

%     f1 = [0 0 2*Lf_1'*A1];
    f2 = [0 2*Lf'*A];
    
    Aineq2 = [
        -1 psi_14'*A_4;
        0 -Lgf_h*B_full;
        0 -Lgf_h2*B_full;
        zeros(8,1) -Lgf_h3*B_full;
        zeros(8,1) -Lgf_h4*B_full;
        zeros(15,1) eye(15);
        zeros(15,1) -eye(15)
];

    b2 = [
         -psi_04-psi_14'*Lf4;
         Lff_h+alpha_1*h_act + alpha_2*h_act_dot;
         Lff_h2+alpha_21*h_2 + alpha_22*h_2_dot;
         Lff_h3+alpha_31*h_3 + alpha_32*h_3_dot;
         Lff_h4+alpha_31*h_4 + alpha_32*h_4_dot;
         uMAX*ones(15,1);
         uMIN*ones(15,1)
         ];

    Aeq2 = [
        0 psi_11'*A_1;
        0 psi_12'*A_2;
        0 psi_13'*A_3;
    ];
    beq2 = [
        psi_11'*A_1*u(2:end);
        psi_12'*A_2*u(2:end);
        psi_13'*A_3*u(2:end)
    ];

    
    u = quadprog(H2,f2,Aineq2,b2,Aeq2,beq2,lb,ub,[],opts);

    
    
    u = u(2:end);
    u_prev = u;
    out = [u; att_d; pos_d];
    
    disp(['Elapsed time: ' num2str(t)])
end
