function f1 = comp_f1(x)
%COMP_F1 Summary of this function goes here
%   Detailed explanation goes here
snake = evalin('base', 'snake');
pp = evalin('base','pp');
K_1 = evalin('base', 'K_1');
K_2 = evalin('base', 'K_2');
K_3 = evalin('base', 'K_3');
K_4 = evalin('base', 'K_4');
K_att_dot = evalin('base', 'K_att_dot');
K_att = evalin('base', 'K_att');
%Get states
% snake     =  x(end)
pos       =  x(1:3);
quat      =  x(4:7);
theta     =  x(8 : 15);
zeta      =  x(16 : 29);
t         =  x(end);

%Compute rotation matrices and jacobians
    [R, J]    =  comp_rot_jac(quat,theta,snake);

    J_dot    = comp_jac_dot(theta, snake, J, zeta(7:end));


    Lambda_1_dot = [K_3*eye(3) zeros(3,3); zeros(3,3) K_att_dot*eye(3)];
    
        H_be = snake.joint(1).A(theta(1))*snake.joint(2).A(theta(2))*snake.joint(3).A(theta(3))*snake.joint(4).A(theta(4))*snake.joint(5).A(theta(5))*snake.joint(6).A(theta(6))*snake.joint(7).A(theta(7))*snake.joint(8).A(theta(8));
    % Position of end-effector in body-fixed base frame.
    pos_endeff = H_be*[snake.link(9).length;0;0;1];
    % Position of end-effecter in the inertial frame.
    p_endeff = pos + R(:,:,1)*pos_endeff(1:3);

    
    
    
    
    if t < 50
        psi_d = pi/2;
        phi_d = 0;
        theta_d = 15*pi/180;
        sigma_1d = [1;2;-10];
    elseif t < 100
        phi_d = -15*pi/180;
        psi_d = pi/4;
        theta_d = 30*pi/180;
        sigma_1d = [2;1;-10];
    elseif t < 150
        phi_d = 0;
        psi_d = 0;
        theta_d = 0;
        sigma_1d = [2;0;-10];
    else
        phi_d = 0;
        psi_d = 0;
        theta_d = 0;
        sigma_1d = [3.1;0;-10];
    end
    omega_d = 0;

    
    att_d = [phi_d theta_d psi_d]';
    quat_d = eul2quat(att_d', 'XYZ')';
    quat_endeff = rotm2quat(R(:,:,9))';
    eta_d = quat_d(1);
    epsilon_d = quat_d(2:4);
    eta = quat_endeff(1);
    epsilon = quat_endeff(2:4);
    T_0b = TransAngQ(quat_endeff);
    qe = [eta_d*eta+epsilon_d'*epsilon;
         eta*epsilon_d-eta_d*epsilon-Smtrx(epsilon_d)*epsilon];
    
    V_e = J(:,:,9)*zeta;
    q_dot = T_0b*V_e(4:6);
    
    sigma_1_tilde = [sigma_1d - p_endeff; qe(2:4)];
    sigma_1_tilde_dot = [0-R(:,:,9)*V_e(1:3); omega_d-R(:,:,9)*V_e(4:6)];
    sigma_2d = [0 0 -10]';
    sigma_2_tilde = sigma_2d - pos;
    sigma_2_tilde_dot = - R(:,:,1)*zeta(1:3);
    

    
    Sigma_1 = [K_1*eye(3) zeros(3,3); zeros(3,3) K_att*eye(3)];

    
    Sigma_2 = K_2*eye(3);
    Lambda_2_dot = K_4*eye(3);
    
     T_0b_dot = 1/2.*[0 -1 0 0 0 0 -1 0 0 0 0 -1;
                1 0 0 0 0 0 0 -1 0 0 1 0;
                0 0 0 1 1 0 0 0 0 -1 0 0;
                0 0 -1 0 0 1 0 0 1 0 0 0]*kron(eye(3),q_dot);   
    J_1 = [R(:,:,9) zeros(3,3); zeros(3,3) T_0b(2:4,:)]*J(:,:,9);
    J_1_dot = [R(:,:,9)*Smtrx(V_e(4:6)) zeros(3,3); zeros(3,3) T_0b_dot(2:4,:)]*J(:,:,9) + [R(:,:,9) zeros(3,3); zeros(3,3) T_0b(2:4,:)]*J_dot(:,:,9);

    J_2 = [R(:,:,1) zeros(3,3+snake.n-1)];      % Base Jacobian
    J_2_dot = [R(:,:,1)*Smtrx(zeta(4:6)) zeros(3,3+snake.n-1)];
    
    
    J_1_inv = J_1'/(J_1*J_1');
    J_2_inv = J_2'/(J_2*J_2');
    N_1 = eye(14) - J_1_inv*J_1;
f1 = J_1_inv*(Sigma_1*sigma_1_tilde + Lambda_1_dot*sigma_1_tilde_dot - J_1_dot*zeta) + N_1*J_2_inv*(Sigma_2*sigma_2_tilde + Lambda_2_dot*sigma_2_tilde_dot - J_2_dot*zeta);
end

